// VCPlug.cpp : Implementation of CVCPlug
#include "stdafx.h"
#include "NewIntf.h"
#include "VCPlug.h"
#include "shlobj.h"
#include "windows.h"


/////////////////////////////////////////////////////////////////////////////
// CVCPlug


//na bazie szablonu Hello World Win32 App z VC++ 6.0

TCHAR* szTitle = _T("tytul");
TCHAR* szWindowClass = _T("NaszaKlasa");			

ATOM				MyRegisterClass(HINSTANCE hInstance);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);




//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(0, (LPCTSTR)IDI_APPLICATION);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(0, (LPCTSTR)IDI_APPLICATION);

	return RegisterClassEx(&wcex);
}

void ReportError()
{
LPTSTR lpMessage;
DWORD dwErrCode = GetLastError();
FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
   FORMAT_MESSAGE_FROM_SYSTEM,
   NULL,               // no source buffer needed
   dwErrCode,          // error code for this message
   NULL,               // default language ID
   (LPTSTR)&lpMessage, // allocated by fcn
   NULL,               // minimum size of buffer
   NULL);              // no inserts

MessageBox(NULL, lpMessage, TEXT("File Error"),
   MB_ICONSTOP | MB_OK );
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{	
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR* szHello = _T("Hello world");

	switch (message) 
	{
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			//niszczymy co nam do malowania okna bylo potrzebne
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}




STDMETHODIMP_(ULONG) CVCPlug::Init(struct IPlugsApplication * ap, HWND hw)
{



	 if (MyRegisterClass(hInst)==0){
	     //ReportError(); //<- tylko do debug, nie powinno sie zatrzymywac aplikacji rodzica
		 //nalezy pamietac moze klasa juz istniec lepsza obsluga
	 }

	
   hWnd = CreateWindow(szWindowClass, szTitle, WS_CHILD ,
      10, 10, 200, 200, hw, NULL, hInst, NULL);

   if (!hWnd)
   {      
	 ReportError();
	 return E_FAIL;
   }

   ShowWindow(hWnd, SW_SHOW);
   UpdateWindow(hWnd);

   return S_OK;
}

STDMETHODIMP CVCPlug::Mouse(char* name, int X, int Y) 
{
	 return E_NOTIMPL;
}

STDMETHODIMP CVCPlug::GetName(char* Desc)
{
	 return E_NOTIMPL;
}

STDMETHODIMP CVCPlug::FreePlug()
{
	 DestroyWindow(hWnd);
     hWnd = 0;
	 return S_OK;
}