#ifndef _MYINTERFACE_H
#define _MYINTERFACE_H



#undef  INTERFACE

#define INTERFACE IPlugsApplication
DECLARE_INTERFACE_(IPlugsApplication, IUnknown)
{
    STDMETHOD(QueryInterface)(THIS_ REFIID,PVOID*) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;
	STDMETHOD(ChangeColor)(THIS_ LONG) PURE;                                      
	STDMETHOD(GetHandle)(THIS_ HWND) PURE;
};
typedef IPlugsApplication *    LPPLUGSAPPLICATION;

#undef  INTERFACE

DEFINE_GUID(IID_IPlug,  0xE2F26AD7, 0x4A48, 0x4CE4, 0x8C, 0xC8, 0x76, 0x19, 0x2E, 0x0E, 0x96, 0x40);

#define INTERFACE IPlug
DECLARE_INTERFACE_(IPlug, IUnknown)
{
    STDMETHOD(QueryInterface)(THIS_ REFIID,PVOID*) PURE;
	STDMETHOD_(ULONG,AddRef)(THIS) PURE;
	STDMETHOD_(ULONG,Release)(THIS) PURE;
    STDMETHOD_(ULONG,Init)(THIS_ struct IPlugsApplication *, HWND) PURE;
    STDMETHOD(Mouse)(THIS_ char* name, int X, int Y) PURE;
    STDMETHOD(GetName)(THIS_ char* Desc)PURE;
    STDMETHOD(FreePlug)(THIS) PURE;
};
typedef IPlug *    LPPLUG;

#undef  INTERFACE



#endif
