// VCPlug.h : Declaration of the CVCPlug

#ifndef __VCPLUG_H_
#define __VCPLUG_H_

#include "resource.h"       // main symbols
#include "MyInterface.h"

extern HINSTANCE hInst; //Instancja biblioteki dll (z DllMain)

/////////////////////////////////////////////////////////////////////////////
// CVCPlug
class ATL_NO_VTABLE CVCPlug : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVCPlug, &CLSID_VCPlug>,
	public IPlug,
	public IDispatchImpl<IVCPlug, &IID_IVCPlug, &LIBID_NEWINTFLib>
{
public:
	HWND hWnd;//uchwyt naszego okna

	CVCPlug()
	{
	}

	
	~CVCPlug()
	{
	  FreePlug();	 
	}

STDMETHOD_(ULONG,Init)(THIS_ struct IPlugsApplication *, HWND);
STDMETHOD(Mouse)(THIS_ char* name, int X, int Y) ;
STDMETHOD(GetName)(THIS_ char* Desc);
STDMETHOD(FreePlug)(THIS) ;

DECLARE_REGISTRY_RESOURCEID(IDR_VCPLUG)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CVCPlug)
	COM_INTERFACE_ENTRY(IVCPlug)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_IPlug,CVCPlug)
END_COM_MAP()

// IVCPlug
public:
};

#endif //__VCPLUG_H_
